// perfTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <math.h>
#include <time.h>
#include <vector>


#include <iostream>

using std::cout;
using std::cin;
using std::endl;

float rnd(float min, float max)
{
	return ((float)rand() / RAND_MAX) * (max-min) + min;
}

long calcPrimes()
{
	time_t start, end;
	double dt = 0;

	long count = 0;
	int curr = 5;
	bool prime;

	while(dt < 1)
	{
		time(&start);
			prime = true;
			for(int chk = 3; chk < curr; chk+=2)
			{
				if(curr%chk==0)
				{
					prime = false;
				}
			}
			if(prime)
				count++;
			curr+=2;
		time(&end);
		dt = difftime(end, start);
	}
	return count;
}

long calcDist()
{
	time_t start, end;
	double dt = 0;
	long count = 0;

	float ar[128][128];


	time(&start);
	while(dt < 1)
	{
		for(int y = 0; y != 128; y++)
		{
			for(int x = 0; x != 128; x++)
			{
				ar[x][y] = sqrt((float)((x^2 - 64^2)+(y^2 - 64^2)));
			}
		}
		count++;

		time(&end);
		dt = difftime(end, start);
	}
	return count;
}

long calcSquares()
{
	time_t start, end;
	double dt = 0;
	long count = 0;
	float x = 0.0f, y = 0.0f;
	float r = 0.0f;

	time(&start);
	while(dt < 1)
	{
		for(int j = 0; j < 524288; j++)
			r = pow(x, y) / pow((sqrt(x) + 0.1f), sqrt(y)) * pow((sqrt(x) / (sqrt(y) + 0.5f)), (sqrt(pow((x*y/7),9))/sqrt(pow(x,y))));
		x+= 0.5f;
		y+= 0.5f;
		
		count++;

		time(&end);
		dt = difftime(end, start);
	}
	return count;
}

long calcBlur()
{
	time_t start, end;
	double dt = 0;
	long count = 0;
	unsigned char ar[256][256];
	long av = 0;

	for(int y = 0; y != 256; y++)
	{
		for(int x = 0; x != 256; x++)
		{
			ar[x][y] = (unsigned char)rnd(0, 255);
		}
	}


	while(dt < 1)
	{
		time(&start);

		for(int y = 4; y != 256 - 4; y++)
		{
			for(int x = 4; x != 256 - 4; x++)
			{
				for(int y2 = y-4; y2 != y+4; y2++)
				{
					for(int x2 = x-4; x2 != x+4; x2++)
					{
						av += ar[x2][y2];
					}
				}
				ar[x][y] = (unsigned char)(av/16);
			}
		}
		count++;

		time(&end);
		dt = difftime(end, start);
	}
	return count;
}

long bigFill()
{
	time_t start, end;
	double dt = 0.0f;
	long count = 0;

	
	float ar1[256][256];
	float ar2[256][256];

	for(int x = 0; x != 256; x++)
	{
		for(int y = 0; y != 256; y++)
		{
			ar1[x][y] = (float)((x * y) ^ (x+y)/(384));
		}
	}
	time(&start);
	while(dt < 1)
	{
		
		for(int n = 0; n != 4; n++)
		{
			for(int x = 0; x != 256; x++)
			{
				for(int y = 0; y != 256; y++)
				{
					ar2[x][y] = (ar1[y][x] - ar1[x][y]) * (ar1[x][y] - ar1[y][x]);
				}
			}
			for(int x = 0; x != 256; x++)
			{
				for(int y = 0; y != 256; y++)
				{
					ar1[x][y] = (ar2[y][x] - ar2[x][y]) * (ar2[x][y] - ar2[y][x]);
				}
			}
		}
		count++;

		time(&end);
		dt = difftime(end, start);
	}
	

	return count;
}

int _tmain(int argc, _TCHAR* argv[])
{
	time_t Tstart, Tend;
	double dt = 0.0f;

	time_t Nstart, Nend;
	double Ndt = 0.0f;

	cout << "Press Enter To Begin\n";
	cin.get();

	time(&Tstart);

	long numA=0, numB=0, numC=0, numD=0, numE=0;
	long total = 0;
	cout << "Prime Test... ";

	time(&Nstart);
	for(int i = 1; i != 11; i++)
	{
		numA += calcPrimes();
		cout << i <<" ";
	}
	time(&Nend);
	dt = difftime(Nend, Nstart);
	numA /= dt;
	cout << "\nPrime Test Score: " << numA << "\n";

	cout << "Distance Test... ";
	for(int i = 1; i != 11; i++)
	{
		numB += calcDist();
		cout << i <<" ";
	}
	cout << "\nDistance Test Score: " << numB << "\n";

	cout << "Square Test... ";
	for(int i = 1; i != 11; i++)
	{
		numC += calcSquares();
		cout << i <<" ";
	}
	cout << "\nSquare Test Score: " << numC << "\n";

	cout << "Blur Test... ";
	for(int i = 1; i != 11; i++)
	{
		numD += calcBlur();
		cout << i <<" ";
	}
	cout << "\nBlur Test Score: " << numD << "\n";

	cout << "Fill Test... ";
	for(int i = 1; i != 11; i++)
	{
		numE += bigFill();
		cout << i <<" ";
	}
	cout << "\nFill Test Score: " << numE << "\n";


	time(&Tend);
	dt = difftime(Tend, Tstart);

	total = (long)(((double)numA + numB + numC + numD + numE) / dt);

	cout << "\nFinal Score: " << total << " (Higher is better)";
	cin.ignore();
	cin.get();

	return 0;
}